Skip to main content
Version: 27.1

Primii pași

Install Jest using yarn:

yarn add --dev jest

Or npm:

npm install --save-dev jest

Note: Jest documentation uses yarn commands, but npm will also work. You can compare yarn and npm commands in the yarn docs, here.

Let's get started by writing a test for a hypothetical function that adds two numbers. First, create a sum.js file:

function sum(a, b) {
return a + b;
}
module.exports = sum;

Then, create a file named sum.test.js. This will contain our actual test:

const sum = require('./sum');
test('adds 1 + 2 to equal 3', () => {
expect(sum(1, 2)).toBe(3);
});

Adăugați secțiunea următoare în fișierul vostru package.json:

{
"scripts": {
"test": "jest"
}
}

Finally, run yarn test or npm run test and Jest will print this message:

PASS ./sum.test.js
✓ adds 1 + 2 to equal 3 (5ms)

Tocmai ați scris cu succes primul test folosind Jest!

Testul acesta a folosit expect și toBe pentru a testa dacă două valori sunt identice. Pentru a afla mai multe lucruri pe care Jest le poate testa, vezi Utilizarea regulilor de potrivire.

Rularea din linia de comandă#

You can run Jest directly from the CLI (if it's globally available in your PATH, e.g. by yarn global add jest or npm install jest --global) with a variety of useful options.

Iată cum să executaţi Jest pe fişierele my-test, folosind config.json ca fişier de configurare şi afişarea unei notificări native de sistem după rulare:

jest my-test --notify --config=config.json

Dacă doriţi să aflaţi mai multe despre rularea jest prin linia de comandă, vezi pagina de Opțiuni Jest pentru linia de comandă.

Informații suplimentare#

Generate a basic configuration file#

Based on your project, Jest will ask you a few questions and will create a basic configuration file with a short description for each option:

jest --init

Folosind Babel#

To use Babel, install required dependencies via yarn:

yarn add --dev babel-jest @babel/core @babel/preset-env

Configure Babel to target your current version of Node by creating a babel.config.js file in the root of your project:

// babel.config.js
module.exports = {
presets: [['@babel/preset-env', {targets: {node: 'current'}}]],
};

The ideal configuration for Babel will depend on your project. See Babel's docs for more details.

Making your Babel config jest-aware

Jest will set process.env.NODE_ENV to 'test' if it's not set to something else. You can use that in your configuration to conditionally setup only the compilation needed for Jest, e.g.

// babel.config.js
module.exports = api => {
const isTest = api.env('test');
// You can use isTest to determine what presets and plugins to use.
return {
// ...
};
};

Notă: babel-jest se instalează automat când instalaţi Jest şi va transforma automat fişierele în cazul în care o configuraţie Babel există în proiectul vostru. Pentru a evita acest comportament, aveţi posibilitatea să reiniţializaţi explicit opţiunea de configurare transform:

// jest.config.js
module.exports = {
transform: {},
};
Babel 6 support

Jest 24 dropped support for Babel 6. We highly recommend you to upgrade to Babel 7, which is actively maintained. However, if you cannot upgrade to Babel 7, either keep using Jest 23 or upgrade to Jest 24 with babel-jest locked at version 23, like in the example below:

"dependencies": {
"babel-core": "^6.26.3",
"babel-jest": "^23.6.0",
"babel-preset-env": "^1.7.0",
"jest": "^24.0.0"
}

While we generally recommend using the same version of every Jest package, this workaround will allow you to continue using the latest version of Jest with Babel 6 for now.

Folosind Webpack#

Jest poate fi utilizat în proiecte care folosesc webpack pentru gestionarea fișierelor statice, stiluri şi compilare. webpack oferă unele provocări unice față de alte instrumente. Urmați ghidul webpack pentru a începe.

Using parcel#

Jest can be used in projects that use parcel-bundler to manage assets, styles, and compilation similar to webpack. Parcel requires zero configuration. Refer to the official docs to get started.

Folosind TypeScript#

Jest supports TypeScript, via Babel. First, make sure you followed the instructions on using Babel above. Next, install the @babel/preset-typescript via yarn:

yarn add --dev @babel/preset-typescript

Then add @babel/preset-typescript to the list of presets in your babel.config.js.

// babel.config.js
module.exports = {
presets: [
['@babel/preset-env', {targets: {node: 'current'}}],
+ '@babel/preset-typescript',
],
};

However, there are some caveats to using TypeScript with Babel. Because TypeScript support in Babel is purely transpilation, Jest will not type-check your tests as they are run. If you want that, you can use ts-jest instead, or just run the TypeScript compiler tsc separately (or as part of your build process).

You may also want to install the @types/jest module for the version of Jest you're using. This will help provide full typing when writing your tests with TypeScript.

For @types/* modules it's recommended to try to match the version of the associated module. For example, if you are using 26.4.0 of jest then using 26.4.x of @types/jest is ideal. In general, try to match the major (26) and minor (4) version as closely as possible.

yarn add --dev @types/jest